/* $Id: ReadCent.java,v 1.4 2009/05/05 09:12:42 mit Exp $ */
/* ReadCent.java v0.1.1 */
import java.io.*;
import java.net.*;
import java.util.*;

public class ReadCent {
    private static final int KB = 88;
    private static int count;
    private static double[] cent;
    private static String Fname;
    private static String Error;

    public ReadCent(URL url) {
      	int m;
	String line, s;
	StringTokenizer tk;
	count = 0;
	cent = new double[KB];
	Error = "";

	try {
	    BufferedReader bf = 
		new BufferedReader(new InputStreamReader(url.openStream()));

	    while((line = bf.readLine()) != null) {
		tk = new StringTokenizer(line, ","); // 1ɹ
		m = tk.countTokens();

		for(int j = 0; j < m; j++) {  // data read
		    try {
			s = tk.nextToken();
			if (count == 0)
			    Fname = s;
			else
			    cent[count-1] = Double.valueOf(s).doubleValue();
			count++;
		    }
		    catch (NoSuchElementException e0) {
			Error = "No Token.";
		    }
		    catch(NumberFormatException e) {
			count--;
			Error = "#"+count+" Read Data Error.";
		    }
		}
	    }
	    bf.close();
	    count--;
	} catch (FileNotFoundException e) {
	    Error = "Not found.";
	} catch (IOException e) {
	    Error = "Not Open.";
	}
    }

    public static int getCount() {
	return count;
    }
    public static double[] getCData() {
	return cent;
    }
    public static String getFname() {
	return Fname;
    }
    public static String getError() {
	return Error;
    }
}