/* $Id: ReadTemper.java,v 1.3 2009/05/05 09:14:16 mit Exp $ */
/* ReadTemper.java v0.3 */
import java.io.*;
import java.net.*;
import java.util.*;

public class ReadTemper {
    private final int Oct = 12;
    private static Vector temper;
    private static String Error;
    private static int count;

    public ReadTemper(URL url) {
	double[] tmp = new double[Oct];
	String line, s, name = "", type = "";
	StringTokenizer tk;
	Error = "";
	Temperament T;
	temper = new Vector();

	try {
	    BufferedReader bf = 
		new BufferedReader(new InputStreamReader(url.openStream()));
	    count = 0;
	    while((line = bf.readLine()) != null) {
		tk = new StringTokenizer(line, ",");
		if (tk.countTokens() != Oct+2)
		    Error = "Data error:"+count;

		name = tk.nextToken();
		type = tk.nextToken();
		for(int j = 0; j < Oct; j++) {
                    try {
                        s = tk.nextToken();
			tmp[j] = Double.valueOf(s).doubleValue();
		    }
		    catch (NoSuchElementException e) {
                        Error = "No Token:"+count;
                    }
                    catch (Exception e) {
                        Error = "Token over:"+count;
                    }
                }

		T = new Temperament(name, type, tmp);
		temper.addElement(T);
		count++;
	    }
            bf.close();
        } catch (FileNotFoundException e) {
            Error = "Not found.";
        } catch (IOException e) {
            Error = "Not Open.";
        }
    }

    public static int getCount() {
	return count;
    }
    public static Vector getTemper() {
	return temper;
    }
    public static String getError() {
	return Error;
    }
}