/* $Id: ReadWire.java,v 1.5 2007/04/23 01:01:13 mit Exp $ */
/* ReadWire.java v0.3.1 */
import java.io.*;
import java.net.*;
import java.util.*;

public class ReadWire {
    private static int num = 5;
    private static int[] Header = new int[num];
    private static Vector V;
    private static String Error;

    private boolean Csw;
    private BufferedReader bf;

    public ReadWire(URL url) {
	try {
	    Error = "";
	    bf = new BufferedReader(new InputStreamReader(url.openStream()));

	    this.readHeader();
	    Csw = (Header[4] > 0) ? true : false;
	    this.readWire();

	} catch (FileNotFoundException e1) {
            setError("File not found.");
        } catch (IOException e2) {
            setError("Can not Open.");
        }
    }

    public static int[] getHeader() {
	return Header;
    }
    public static Vector getWire() {
        return V;
    }
    public static int getAllWire() {
	return V.size();
    }
    public static String getError() {
	return Error;
    }

    public void close() {
	try {
	    bf.close();
	} 
	catch (Exception e) {
	    setError("c:"+e.toString());
	}
    }
    public void readHeader() {
	String line;
	String[] s = new String[num];

	try {
	    line = bf.readLine();
	    if (line == null)
		close();
	    
	    s = StoS(line);
	    for (int i = 0; i < num; i++)
		Header[i] = (s[i] == null) ? 0 : Integer.parseInt(s[i]);

	    Wire.setHeader(Header);
	} catch (Exception e) {
	    setError("h:"+e.toString());
	}
    }
    public void readWire() {
	String line;
	String[] s = new String[num];
	double[] data = new double[num];
	Wire gen;
	V = new Vector();

	try {
	    for (;;) {
		line = bf.readLine();
		if (line == null)
		    break;

		s = StoS(line);
		for (int i = 0; i < num; i++)
		    data[i] = (s[i] == null) ? 0 : Double.valueOf(s[i]).doubleValue();

		gen = new Wire(data);
		V.addElement(gen);
	    }

	    close();
	} catch (Exception e) {
	    V = null;
	    setError("w:"+e.toString());
	}
    }
    public void setError(String text) {
	Error = text;
    }
    public String[] StoS(String val) {
	String[] temp = new String[num];
	StringTokenizer tk = new StringTokenizer(val, ",");
	int num = tk.countTokens();

	for (int i = 0; i < num; i++) {
	    try {
		temp[i] = tk.nextToken();
	    }
	    catch (NoSuchElementException e0) {
		setError("No Token.");
	    }
	    catch(NumberFormatException e) {
		setError("Data Read Error.");
	    }
	}

	return temp;
    }
}