/* $Id: jt.java,v 1.123 2013/12/03 00:58:22 mit Exp $ */
/* jt.java v2.9.5 */
import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;
import java.util.*;
import java.text.DecimalFormat;

public class jt extends Applet 
    implements ActionListener, ItemListener, AdjustmentListener,
    MouseListener, MouseMotionListener, Runnable
{
    private Choice chCNT;       // cent
    private Choice chTUN;       // tuning
    private Choice chSW;        // sws
    private Choice chI;         // interval
    private Choice chINH;       // inharmo.
    private TextField tfA;
    private TextArea taA;
    private Button btM, btP;    // -,+
    private Button btN, btW;    // narrow,wide
    private Button btU, btD;    // /,x
    private Button btSC;        // curve/straight
    private Button[] btKeys;    // ->|>|>>
    private Button btV[];       // graph.,text
    private Scrollbar sbW;
    private Scrollbar sbL, sbO;
    private Canvas can;
    private Label lCent;
    private Label lBeat;
    private Panel deck;
    private CardLayout Card;
    private Thread thr;
    private Panel PN, PW, PE, PD;

    final Color C0 = Color.magenta; // base.c
    final Color Cn = Color.green;   // now.c
    final Color Cc = Color.pink;    // copper.c
    final Color Cw = Color.white;   // wire.c
    final Color Ci = Color.yellow;  // interval.c
    final Color Cb = Color.orange;  // beats.c
    final Color Cr = Color.pink;    // back.c
    final Color Cst = new Color(00,150,255); // strees.c
    final Color[] Cs = {new Color(200,10,50), new Color(200,140,30),
			new Color(180,200,20), new Color(20,200,30),
			new Color(120,20,200)}; // separate color
    final static int CENT = 0;       // view
    final static int BEAT = 1;       // "
    final static int INTE = 2;       // "
    final static int INHA = 3;       // "
    final static int WIRE = 4;       // "
    final static int LAYY = 5;       // "
    final static int SEPA = 6;       // "
    final static int DATA = 7;       // "
    final static int IH0 = 0;        // inha. null
    final static int IHL = 1;        // " laible
    final static int IHN = 2;        // " new
    final static int OCT = 12;       // interval 2:1
    final static int OCT2 = OCT*2;
    final static int MJ3 = 4;        // MJ3rd
    final static int MI6 = 8;        // mi6th
    final static int P4 = 5;         // " 4:3 
    final static int P5 = 7;         // " 3:2
    final static int NOTMOVE = 0;    // mouse 0
    final static int GREEN = 1;      // " 1
    final static int MAGENTA = 2;    // " 2
    final static int NOT = -1;       // tun not
    final static int LAY = 0;        // " laying
    final static int EXT = 1;        // " extension
    final static int SPR = 2;        // " separate
    final static int PYT = 3;        // " pythagoras
    final static int OC2 = 4;        // " 2octave
    final static int FRM = 5;        // " formula
    final static int DWIRE = 0;      // data select
    final static int DCENT = 1;      // "
    final static int DTMPF = 2;      // "
    final static int DTMPD = 3;      // "
    final static int Pmax = 20;
    final static int Cent = 1200;
    final static int Octb = 13;
    final static int KB = 88;        // all key
    final static int KA = KB+OCT*3;
    final static int Knmax = 28;      // ̾ɽκ
    final static int Tmax = 150;      // tension max[kg]
    final static int Imax = 1000;     // inter. max
    final static int Maxw = 110;      // 縹?
    final static double MC = Cent/Math.log(2);

    final static String Sel_btn = "Select";
    final static String Head1 = "Wire#:Key#  [Hz]: ";
    final static String[] tun = {
	"Laying","Extension","Separate","Pythagoras","2octave","Formula"};
    final static String[] view = {
	"Cent","Beat","Inte.","inHa.","Wire","Layi.","Sepa.","Data", "Text"};
    final static String[] octnm = {
	"A2","A1","A","a","a1","a2","a3","a4"};
    final static String[] cent = {
	"0.001","0.01","0.05","0.1","0.5","1.0","5.0","10.0"};
    final static String[] keynm = 
    {"A..","B..","H..","C..","Cis","D..","Es.","E..","F..","Fis","G..","Gis"};
    final static String[] sws = 
    {"Curve","A:440","Chord","Stress","Type","Cent.txt","Partial"};
    final static int[] SEPKEY = {0,12,24,48,60};  // separate key
    final static String[] Dfiles =
    {"Wire Data","Cent Data","Temperament File","Temperament Data"};
    final static String[] Inharmo = {"0","L","N"};
    final static String[] Keys = {"->",">",">>"};
    private static final long serialVersionUID = 1L;

    int FB;             // start key# 0~
    int AW;             // all wire
    Vector T;           // for Temperament
    Keyboard[] K;
    Interval I;
    TuningFormula2 TF2;

    int W = 550;        // canvas width
    int H = 300;        // canvas height
    int HH = H/2;
    int FNT;
    int RW;             // ܤα
    int RH;             // dataܥι⤵
    int WN;             // wire#
    int BW;             // beats wire
    int Prt = 10;       // partial
    int Bmax = 20;      // beats max
    int Cmax = 100;     // cent max
    int Bby = Bmax;     // beats max
    int Bb = 3;         // beats band
    int Vsw = CENT;     // view sw.
    int Tsw = NOT;      // tune sw.
    int Lmax = 2200;    // 縹Ĺmm
    int START;
    int ENDW;
    int Dot;
    int Dsf;            // Dot/2
    int File;               
    int Chord = 3;
    int MP;             // max partial
    int HS;             // height shift
    int WS;             // width shift
    int HT;             // HH-Dsf
    int WST;            // WS-Dsf
    int mK;             // mouse key#
    int mX, mY;         // mouse x/y
    int Inum = 0;       // interval#
    int Ix = Imax/20;   // inter. start
    int Tnum = 50;      // max 50?
    int Mmv;            // mouse move
    int Octave;         // 2:1
    int P4th;           // 4:3 
    int P5th;           // 3:2
    int Dsel;
    int Dnum;
    int Cnum = -1;      // cent data #
    int Tname;          // T file name
    int Dstt = 0;
    int INH;
    int PART = 1;       // partial max
    double TD;          // ĥñ
    double BD;          // 縹Ĺmm
    double mC;          // for mouse cent
    double AA = 440.0;
    double Aa = AA;
    double Ct;          // cent
    double WD;
    double HD;
    double DH;          // cent max
    double LY;          // scrL
    double OV;          // scrO
    double Bmin;        // min beats
    boolean GU;         // gp/up face
    boolean ES;         // e/s curve
    boolean VS;         // view sw.
    boolean PS;         // pitch sw.
    boolean SS;         // stress sw.
    boolean Rev;        // ->,<- sw.
    boolean SLCT;       // data select button
    boolean RP, RM;     // data +,- button
    boolean CC;         // cent data
    boolean PA;         // partial sw.
    boolean SC;         // straight/curve
    String Error;
    String Fname = "";  // cent file
    String Swork;       // temp data
    String Dirnm;
    Rectangle Select;
    Rectangle Rp, Rm;
    Rectangle[] rdat;
    Rectangle[] rlist;
    Rectangle[] rbeat;
    Rectangle[][] sepa;
    int[] SEP;
    int[] SEPAR;
    double[] Cdata; // read cent data
    double[] Unari;
    double[] Work;
    double[] Equal;
    double[] Ibase;
    String[] Filenm;
    String[] Tempnm;
    String[] Datanm;
    String[] sep;
    String[] Sep_key;

    TuningType TT;
    Font Fnt, Fnm, Fns;
    FontMetrics fm;
    DecimalFormat df0, df1, df2;
    Graphics gi;
    Image im;

    public void init() {
	String fnt = getParameter("font");
	FNT = (fnt != null) ? Integer.parseInt(fnt) : 12;
	Fnt = new Font("SansSerif", Font.PLAIN, FNT);
	Fnm = new Font("SansSerif", Font.PLAIN, FNT+2);
	Fns = new Font("SansSerif", Font.PLAIN, FNT);
	setFont(Fnt);
	fm = getFontMetrics(Fnt);
	df0 = new DecimalFormat("0.0");
	df1 = new DecimalFormat("#0.0##");
	df2 = new DecimalFormat("#0.0####");
	Equal = new double[OCT];

	T = new Vector();
	I = new Interval();
	set_inter();
	buildLayout();
	init_start();
    }
    public void buildLayout() {
        setBackground(Color.lightGray);
        setLayout(new BorderLayout());

	deck = new Panel();
        Card = new CardLayout();
        deck.setLayout(Card);
	int i;

	PN = new Panel();
        PN.setLayout(new GridLayout(2,1,0,0));
        add(PN, "North");

	Panel u1 = new Panel();  // top 1/3
        u1.setLayout(new FlowLayout());
        PN.add(u1);

	Panel u3 = new Panel();   // top 3/3
        u3.setLayout(new FlowLayout());
        PN.add(u3);

	tfA = new TextField(38);
	tfA.setFont(Fns);
        tfA.setEditable(false);
        tfA.addActionListener(this);
        u1.add(tfA);

	String fn = getParameter("all_f");  // wire file
        int af = (fn == null) ? 0 : Integer.parseInt(fn);
        Filenm = new String[af];

        Dirnm = getParameter("dirnm");
        Dirnm = (Dirnm == null) ? "" : Dirnm;

        for (i = 0; (fn = getParameter("mwdata"+i)) != null; i++)
            Filenm[i] = fn;

	u1.add(new Label("| Tune", Label.RIGHT));

	chTUN = new Choice();     // tuning
	for (i = 0; i < tun.length; i++)
	    chTUN.addItem(tun[i]);
	chTUN.addItemListener(this);
	u1.add(chTUN);

	chINH = new Choice();     // inharmonicity
	for (i = 0; i < Inharmo.length; i++)
	    chINH.addItem(Inharmo[i]);
	INH = IHL;
	chINH.addItemListener(this);
	u1.add(chINH);

	btSC = new Button(" Curve ");
        btSC.addActionListener(this);
        u1.add(btSC);
	//------------u1/

	String tm = getParameter("all_t");
	int at = (tm == null) ? 0 : Integer.parseInt(tm);
        Tempnm = new String[at];
        for (i = 0; (tm = getParameter("temper_f"+i)) != null; i++)
            Tempnm[i] = tm;
	init_temp();

	String fd = getParameter("all_d");  // cent file
        int ad = (fd == null) ? 0 : Integer.parseInt(fd);
        Datanm = new String[ad];
        for (i = 0; (fd = getParameter("cdata"+i)) != null; i++)
            Datanm[i] = fd;
	//-----------------/u3

	chSW = new Choice();
	for (i = 0; i < sws.length; i++)  // sws
	    chSW.addItem(sws[i]);
	chSW.addItemListener(this);
	u3.add(chSW);

	u3.add(new Label(" SW.|", Label.LEFT));

        btKeys = new Button[Keys.length];
        for (i = 0; i < Keys.length; i++) {
            btKeys[i] = new Button(Keys[i]);
            btKeys[i].addActionListener(this);
            u3.add(btKeys[i]);
        }

	chI = new Choice();  // interval
	for (i = 0; i < I.getInum(); i++)
	    chI.addItem(I.toString(i));
	u3.add(chI);
	chI.addItemListener(this);
	
	u3.add(new Label("| Cent", Label.RIGHT));

	btM = new Button("-");
	btM.addActionListener(this);
	u3.add(btM);

	btP = new Button("+");
	btP.addActionListener(this);
	u3.add(btP);

	chCNT = new Choice();
	for (i = 0; i < cent.length; i++) // cent
	    chCNT.addItem(cent[i]);
	chCNT.addItemListener(this);
	u3.add(chCNT);
	Ct = 1.0;
	//------------------north/east

	PE = new Panel();
        PE.setLayout(new GridLayout(5,1,0,0));
        add(PE, "East");

	btU = new Button("+");
	btU.addActionListener(this);
	PE.add(btU);

	btD = new Button("-");
	btD.addActionListener(this);
	PE.add(btD);

	PE.add(new Label(""));

	btW = new Button(">");
	btW.addActionListener(this);
	PE.add(btW);

	btN = new Button("<");
	btN.addActionListener(this);
	PE.add(btN);
	//----------east/west

	PW = new Panel();
	PW.setLayout(new GridLayout(view.length+1,1,0,0));
	add(PW, "West");	

	btV = new Button[view.length];
	for (i = 0; i < view.length; i++) {
	    if (i == view.length-1)
		PW.add(new Label(""));
	    btV[i] = new Button(view[i]);
	    btV[i].addActionListener(this);
	    PW.add(btV[i]);
	}
	//-----------------west/south

	PD = new Panel();
        PD.setLayout(new GridLayout(2,1,0,0));
        add(PD, "South");

	Panel p1 = new Panel();        // 1/2
        p1.setLayout(new GridLayout(1,2,0,0));
        PD.add(p1);
         
	Panel p2 = new Panel();        // 2/2
        p2.setLayout(new GridLayout(1,4,0,0));
        PD.add(p2);

	sbW = new Scrollbar(Scrollbar.HORIZONTAL, 1, 1, 0, 10);
        p1.add(sbW);
        sbW.addAdjustmentListener(this);

	sbL = new Scrollbar(Scrollbar.HORIZONTAL, 20, 10, -130, 130);
	sbL.setBlockIncrement(10);
	sbL.setUnitIncrement(1);
        p2.add(sbL);
        sbL.addAdjustmentListener(this);

	lCent = new Label("Laying: ____", Label.CENTER);
	p2.add(lCent);

	int max_beats = 900;
	sbO = new Scrollbar(Scrollbar.HORIZONTAL, 50, 10,
			    -max_beats+10, max_beats+10);
       	sbO.setBlockIncrement(10);
	sbO.setUnitIncrement(1);
	p2.add(sbO);
        sbO.addAdjustmentListener(this);

	lBeat = new Label("Interval: ____", Label.CENTER);
	p2.add(lBeat);
	//---------south/center

	can = new MyCanvas();

	Panel graph = new Panel();
        graph.add(can);
        deck.add(graph, "graph");

        taA = new TextArea("", 16, 50, TextArea.SCROLLBARS_BOTH);
	taA.setFont(Fns);
        taA.setEditable(false);

        ScrollPane Text = new ScrollPane();
        Text.add(taA);

        deck.add(Text, "text");
        add(deck, "Center");

	can.addMouseListener(this);
        can.addMouseMotionListener(this);
    }
    public void init_start() {
	K = new Keyboard[KB];
	Cdata = new double[KB];
	Unari = new double[Pmax+1];
	Work = new double[OCT];
	Ibase = new double[KB];
	RH = FNT+2*2;
	WN = 49-1;

	chINH.select(INH); // inha.
	chCNT.select(""+Ct); //
	set_keyboard(); //
    }
    public void start() {
	W = getCanvaSize().width;
	H = getCanvaSize().height;

	can.setSize(W, H);
	im = createImage(W, H);
	gi = im.getGraphics();
	gi.setFont(Fnt);

	setD();
	set_keyboard_max(); //
	init_buttons();     // read_file

	START = FB;
	ENDW = AW-FB; //
    }
    public void destroy() {
	K[0].setReStart();
	for (int i = 0; i < KB; i++)
	    K[i].setClear();
    }
    public Dimension getCanvaSize() {
	Dimension dn = PN.getSize(); // north
	Dimension de = PE.getSize(); // east
	Dimension dw = PW.getSize(); // west
	Dimension ds = PD.getSize(); // south
	Dimension dp = getSize();
	int w = dp.width-(de.width+dw.width);
	int h = dp.height-(dn.height+ds.height)-10;
	Dimension x = new Dimension(w, h);

	return x;
    }
    public void init_buttons() {
	setInterval();
        read_wire(Filenm[0]);
	read_tempf(0);
	set_separate();
	set_rpm();
	set_select();
	set_dfiles();
    }
    public void set_rpm() {
	int rw = 30, sf = 2, w0 = 80;
	Rp = new Rectangle(w0, H-RH-sf, rw, RH);
	Rm = new Rectangle(w0, sf, rw, RH);
    }
    public void set_select() { // select button
	int x0 = fm.stringWidth(Sel_btn);
	Select = new Rectangle(80, H-70, x0+10, RH);
    }
    public void set_rlist(int st, int x, int y, int w) {
	rlist = new Rectangle[st];
	for (int i = 0; i < st; i++)
	    rlist[i] = new Rectangle(x, y+RH*i, w, RH);
    }
    public int get_maxlength(String[] data) {
	int max = 0, maxi = 0;
	for (int i = 0; i < data.length; i++) {
	    if (max < data[i].length()) {
		max = data[i].length();
		maxi = i;
	    }
	}
	return maxi;
    }
    public void set_dfiles() { // data
	rdat = new Rectangle[Dfiles.length];
	RW = fm.stringWidth(Dfiles[3]+"00");
	int sx = 20, sy = 80, y0 = 10;
	for (int i = 0; i < Dfiles.length; i++)
	    rdat[i] = new Rectangle(sx, sy+(RH+y0)*i, RW, RH);
    }
    public void set_rbeat(int sf, int x0, double dh) { // beat
	rbeat = new Rectangle[Pmax];
	int x = 1;
	for (int i = 0; i < Pmax; i++)
	    rbeat[i] = new Rectangle(x, (int)(sf-dh*(i-1)-24), x0-x, (int)dh);
    }
    public void set_separate() {
	int y = HH, h = FNT+6, i,j;
	int w = fm.stringWidth("00 : 00");
	sep = new String[6];         // ܥνĥο or 6???
	SEP = new int[sep.length];   // 襴ȥβ¸
	SEPAR = new int[sep.length]; // ܥβ¸ 
   	int[] x = new int[SEPKEY.length];
	Sep_key = new String[SEPKEY.length]; // ϰ̾
	sepa = new Rectangle[SEPKEY.length][sep.length]; // ܥ
	double dw = (W-w*SEPKEY.length)/(double)(SEPKEY.length+1);

	for (i = 0; i < sep.length; i++) {
	    sep[i] = I.getIlow(i)+" : "+I.getIhigh(i); // Inteval0~5
	    SEPAR[i] = i;                // ܥβ
	}

	for (i = 0; i < sep.length-1; i++)
	    SEP[i] = SEPAR[sep.length-2-i]; // 򥻥å 4,3,2,1,0,0

	for (i = 0; i < SEPKEY.length; i++)
	    x[i] = (int)(dw+i*(dw+w));  // ֥

	for (i = 0; i < sepa.length; i++) { // Ĳ򥻥å
	    for (j = 0; j < sepa[0].length; j++)
		sepa[i][j] = new Rectangle(x[i], y+j*(h+1), w, h); 
	}
    }
    public void set_sepkey() {
        String str;
        int i, end;
        for (i = 0; i < SEPKEY.length-1; i++) { // ΰ̾
            if (SEPKEY[i+1] <= FB)
                str = "<>...<>";
            else if (SEPKEY[i] > FB)
                str = (SEPKEY[i]+1)+"<"+get_keyname(SEPKEY[i])+">..."+SEPKEY[i+1];
            else
                str = (FB+1)+"<"+get_keyname(FB)+">..."+SEPKEY[i+1];

            Sep_key[i] = str;
        }

        end = wtok(AW-1); //   end = get_maxKey();
        Sep_key[i] = (SEPKEY[i]+1)+"<"+get_keyname(SEPKEY[i])+
            ">..."+end+"<"+get_keyname(end-1)+">";
    }
    public void set_inter() {
	Octave = I.getIinte(OCT);  // 2:1
	P4th = I.getIinte(P4);     // 4:3 
	P5th = I.getIinte(P5);     // 3:2
    }

    public void set_temper() {
	int knum = BW-4;  // f~
	for (int i = 0; i < OCT; i++) {
	    int t = i+5;  // f~
	    if (t >= OCT)
		t -= OCT;
	    set_icent(knum+i, t*100-Work[t]);
	} 
    } 
    public void read_tempf(int num) {
	try {
            URL url = new URL(getDocumentBase(), Dirnm+Tempnm[num]);
            ReadTemper rt = new ReadTemper(url);

	    T = rt.getTemper();
            Tnum = rt.getCount();
            Error = rt.getError();
        } catch(Exception e) {
            Error = "File read error."+e;
        }
	if (Error.equals("")) {
	    addTempEqual();
	    Tnum = (Tnum < 0) ? 0 : T.size();
	    set_temp_work(0);
	}
    }
    public void init_temp() {
	for (int i = 0; i < OCT; i++)   // +equal
             Equal[i] = i*100;

	addTempEqual();
	Swork = getTempString(0);
    }
    public void set_temp_work(int num) {
	Work = getTempData0(num);
	Swork = getTempString(num);
    }
    public void addTempEqual() {
	T.addElement(new Temperament("Equal", "C", Equal));
    }
    public double[] getTempData0(int num) {
	return ((Temperament)T.elementAt(num)).getTemper();
    }
    public String getTempString(int num) {
	return ((Temperament)T.elementAt(num)).toString();
    }
    public String getTempName(int num) {
	return ((Temperament)T.elementAt(num)).getTemp();
    }

    public void read_wire(String fn) {
 	tfA.setText("");

	try {
	    URL url = new URL(getDocumentBase(), Dirnm+fn);
            ReadWire rw = new ReadWire(url);

            int[] head = rw.getHeader();
	    Vector vw = rw.getWire();
            AW = rw.getAllWire();
            Error = rw.getError();
            FB = head[3];
	    TT = new TuningType(vw, head); //
	    TT.setItype(INH);  // inha
	    TT.setInterval(Inum);

	    //debug();
        } catch(Exception e) {
            Error = "File read error.";
        }
	if (Error.equals("")) {
	    TF2 = new TuningFormula2();
            Ibase = TF2.getInharmonicity(get_inharmo());

	    ch_classic();
	    SLCT = true;
	}
    }
    public void debug() {
	for (int i = 0; i < AW; i++)
	    System.out.println(i+": "+wtok(i)+": "+
		 	       get_freq(i)+" "+get_cent(i)+" "+
			       TT.getVinhar(i)+" "+TT.getBinhar(i, 1)+" "+getInha(i));
    }
    public boolean isFile() {
        return (TT != null);
    }
    public double[] get_inharmo() {
        double[] tmp = new double[KB];
        int wn;

	for (int i = 0; i < get_maxKey(); i++) {
            wn = ktow(i+1);
            if (isLength(wn)) // no wire
                continue;

            tmp[i] = getInha(wn);
        }

        return tmp;
    }
    public int get_maxKey() {
	return wtok(AW-1);
    }
    public void read_cent(int n) {
	tfA.setText("");

	try {
            URL url = new URL(getDocumentBase(), Dirnm+Datanm[n]);
            ReadCent rc = new ReadCent(url);

	    Cdata = rc.getCData();
	    Fname = rc.getFname();
	    Error = rc.getError();
	} catch(Exception e) {
            Error = "File read error."+e;
        }
	if (Error.equals("")) {
	    ES = true;           // set_freq() sw
	    intw(getacent());
	}
    }

    public void ch_classic() {
	boolean cb = TT.isPiano(); // harpsichord/piano
	Chord = cb ? 1 : 3;
	PS = cb; // pitch
	GU = cb; // gp/up

	WN = ktow(49);
	ch_pitch();
	set_ratio();
	set_ibase();
    }
    public void set_ibase() {
	if (SC) { // straight
	    int a49 = 49-1;
	    Ibase[a49] = TT.getVinhar(ktow(49));
	    double hi = Math.pow(2*Math.sqrt(2), 1.0/OCT);

	    for (int i = a49+1; i < KB; i++)
		Ibase[i] = Ibase[i-1]*hi;
	    for (int i = a49-1; i >= 0; i--)
		Ibase[i] = Ibase[i+1]/hi;
	} else // curve
            Ibase = TF2.getInha(); //
    }
    public void int_freq() {
        reinit();
	startSEB();
    }
    public void reinit() {
        intw(getacent());
    }
    public void intw(double ac) {
        for (int i = 0; i < AW; i++)
	    set_icent(i, ac);
    }
    public void ch_chord() {
	Chord++;
	if (Chord > 3)
 	    Chord = 1;
    }
   public void ch_pitch() {
	Aa = AA = PS ? 415 : 440;
	chSW.remove(1);
	chSW.insert("A:"+AA, 1);
	int_freq();
    }
    public double getFreq(int key) { // 0~87
	return AA*Math.pow(2, (key-48)/(double)OCT); // 49-1
    }

    public void setSEB(boolean sw) {
	switch (Vsw) {
	case BEAT:
	    int bmax = Integer.MAX_VALUE;
	    Bby = sw ? Bby*2 : Bby/2;
	    if (Bby < 2)
		Bby = 2;
	    else if (Bby > bmax)
		Bby = bmax;
	    break;
	default:
	    ENDW = sw ? ENDW*2 : ENDW/2;

	    if (ENDW >= AW-FB) {
		ENDW = AW-FB;
		START = FB;
	    } else if (ENDW < Octb)
		ENDW = Octb;

	    START = BW-ENDW/2;  // BW濴ȥ
	    if (START < FB)
		START = FB;
	    else if (START+ENDW >= AW-FB)
		START = AW-FB-ENDW;

	    int Dmax = 7;
	    int Dmin = 4;
	    Dot = sw ? --Dot : ++Dot;
	    if (Dot > Dmax)
		Dot = Dmax;
	    else if (Dot < Dmin)
		Dot = Dmin;
	    setD();
	}
    }
    public void setD() {
	WD = (double)(W-1)/ENDW;
	HD = (double)(H-1)/ENDW;
	DH = (double)(H-1)/Cmax;
	sbW.setValues(START, ENDW, FB, AW);
	sbW.setBlockIncrement(ENDW/2);

	HS = (int)(HD/2);
	WS = (int)(WD/2);
	HH = H/2;

	double dt2 = Dot/2.0;
	Dsf = (int)dt2;
	HT = (int)(HH-dt2);
	WST = (int)(WS-dt2); 
    }
    public void startSEB() { // fileɥ߹ν
	START = FB;
	ENDW = AW-FB;
	mK = WN;
	setBaseWire();

	Dot = 4;
	setD();     // WD&HD
	dispinter();
    }
    
    public void mouseMoved(MouseEvent me) { 
	if (Vsw == CENT || Vsw == INTE || Vsw == INHA || Vsw == WIRE) {
	    if (Mmv > NOTMOVE) {   
		mK = m_move(me);
		if (Mmv == GREEN)
		    WN = mK+START;
		else if (Mmv == MAGENTA)
		    BW = mK+START;
		can.repaint();
	    }
	}
    }
    public void mouseClicked(MouseEvent m) {
	mK = m_move(m);
	int wn = mK+START;

	switch (Vsw) {
	case CENT:
	case INTE:
	case INHA:
	case WIRE:
	    if (Mmv > NOTMOVE)   // move off
		Mmv = NOTMOVE;
	    else {               // move on
		if (Vsw == INTE)
		    Mmv = GREEN;
		else {
		    if ((m.getModifiers() & InputEvent.SHIFT_MASK) != 0)
			Mmv = MAGENTA;
		    else if ((m.getModifiers() & InputEvent.CTRL_MASK) != 0)
			Mmv = GREEN;
		    else
			Mmv = near(wn);
		}
		if (Mmv == GREEN)
		    WN = wn;
		else if (Mmv == MAGENTA)
		    BW = wn;
	    }
	    break;
	case SEPA: // for separate button
	    for (int i = 0; i < sepa.length; i++) {
		int n = findrect(m, i);
		if (n >= 0)
		    SEP[i] = SEPAR[n]; // 򥻥å
	    }
	    break;
	case DATA:
	    int d = finder(m, rdat);
	    if (d >= 0)
		Dsel = d;
	    int l = finder(m, rlist);
	    if (l >= 0)
		Dnum = l;
	    SLCT = find_select(m, Select);
	    RP = find_select(m, Rp);
	    RM = find_select(m, Rm);
	    break;
	case BEAT:
	    int p = finder(m, rbeat);
	    if (p >= 0)
		Prt = p+1;
	    break;
	default:
	}

	can.repaint();
    }
    public boolean find_select(MouseEvent e, Rectangle n) {
	int x = e.getX(), y = e.getY();

	return !n.contains(x,y);
    }
    public int finder(MouseEvent e, Rectangle[] n) {
	int x = e.getX(), y = e.getY();
	for (int i = 0; i < n.length; i++) {
            if (n[i].contains(x,y))
		return i;
        }
        return -1;
    }
    public int findrect(MouseEvent e, int n) {
	int x = e.getX(), y = e.getY();

	for (int j = 0; j < sepa[0].length; j++) {
	    if (sepa[n][j].contains(x,y))
		return j;
	}
	return -1;
    }
    public int near(int now) {
        return (Math.abs(WN-now) > Math.abs(BW-now)) ? 2 : 1;
    }
    public void mousePressed(MouseEvent m) { 
	mY = m.getY();
	mC = get_cent(WN);
    }
    public void mouseDragged(MouseEvent me) {
        int dX = me.getX();
        int dY = me.getY();

	switch (Vsw) {
	case CENT:
	case BEAT:
	case INTE:
            double mc = (mY-dY)/DH;
	    set_cent(WN, mc+mC); //
	    break;
	case INHA:
	    int max = 20;
            PART += (int)(max*(mY-dY)/(double)H);
            if (PART > max)
                PART = max;
            else if (PART < 1)
                PART = 1;
	    break;
	default:
	}

	can.repaint();
    }
    public int m_move(MouseEvent e) {
	mX = e.getX();
	mY = e.getY();
	int num = (Vsw == WIRE) ? 
	    (GU ? (int)(mY/HD) : (int)((H-mY)/HD)) : (int)(mX/WD);

	if (num >= ENDW)
	    num = ENDW-1;
	else if (num < 0)
	    num = 0;

	return num;
    }
    public void mouseReleased(MouseEvent m) { }
    public void mouseEntered(MouseEvent m) { }
    public void mouseExited (MouseEvent m) { }

    public void adjustmentValueChanged(AdjustmentEvent e) {
	if (Vsw != BEAT) {
	    if (e.getSource() == sbW)  // wide
		START = sbW.getValue();
	    disp_sw();
	}
	if (e.getSource() == sbL || e.getSource() == sbO)
	    setInterval();
    }
   
    public void actionPerformed(ActionEvent e) {
	for (int i = 0; i < view.length; i++) {  // graph.sw
	    if (e.getSource() == btV[i]) {
		Vsw = i;
		break;
	    } 
	    if (e.getSource() == btV[view.length-1]) { // text
		VS = !VS;
		btV[view.length-1].setLabel(VS ? "Grap." : "Text");
		Card.next(deck);
		break;  // nead
	    }
	}
	
	if (e.getSource() == btM)       // -
	    pm_cent(-Ct);	    
	else if (e.getSource() == btP)  // +
	    pm_cent(Ct);	    

	else if (e.getSource() == btN)  // <
	    setSEB(false);
	else if (e.getSource() == btW)  // >
	    setSEB(true);

	else if (e.getSource() == btU)  // up 
	    setGain(true);
	else if (e.getSource() == btD)  // down
	    setGain(false);

        else if (e.getSource() == btKeys[0]) // ->|<-
            reversKey();
        else if (e.getSource() == btKeys[1]) // <|>
            changeKey(1);
        else if (e.getSource() == btKeys[2]) // <<|>>
            changeKey();

	else if (e.getSource() == btSC) // curve/straight
	    set_itype();

	set_enabled();
	disp_sw();
    }
    
    public void set_enabled() {
	boolean vi = (Vsw == INHA);
	boolean vl = (Vsw == LAYY);
	btU.setEnabled(!(vi || vl || VS)); // up
	btD.setEnabled(!(vi || vl || VS)); // down

	boolean vb = (Vsw == BEAT);
	btN.setEnabled(!(vl || (vb && VS))); // <
	btW.setEnabled(!(vl || (vb && VS))); // >

	boolean vs = (Vsw == SEPA);
	boolean vd = (Vsw == DATA);
	sbW.setEnabled(!(vb || vl || vs || vd)); // scr.wide
    }
    public void itemStateChanged(ItemEvent e) {
	boolean sw = true;    // repaint

	if (e.getSource() == chI)     // ratio
	    select_ratio();

	if (e.getSource() == chCNT) { // cent
	    select_cent();
	    sw = false;        // not paint
	}

	if (e.getSource() == chTUN) // tuning
	    select_tune();

	if (e.getSource() == chSW)  // sw
	    do_command(chSW.getSelectedIndex());

	if (e.getSource() == chINH) // inharmo.
	    select_inha();

	if (sw)
	    disp_sw();
    }
    public void set_itype() {
        SC = !SC;
        btSC.setLabel(SC ? "Straight" : " Curve ");
        set_ibase();
    }
    public void pm_cent(double ce) {
	add_cent(WN, ce);
    }
    public void select_ratio() {
	Inum = chI.getSelectedIndex();  // start 0

	TT.setInterval(Inum);
	set_ratio();
    }
    public void select_cent() {
	int n = chCNT.getSelectedIndex();
	Ct = Double.valueOf(cent[n]).doubleValue();
    }
    public void select_tune() {
	Tsw = chTUN.getSelectedIndex();

	if (Tsw == FRM)
            set_curve();
	else {
	    if (Tsw == SPR)
		TT.setSepKey(SEP, SEPKEY);

	    TT.startRun(OV, LY, BW, Tsw);
	    thr = new Thread(this);
	    thr.start();
	}

    }
    public void set_curve() {
        double[] tmp = TF2.getCurve(OV);

        for (int i = FB; i < AW; i++)
            set_cent(i, tmp[wtok(i)-1]);

        can.repaint();
    }
    public void select_inha() {
	INH = chINH.getSelectedIndex();

	if (TT != null)
	    TT.setItype(INH); //
	set_ih();
    }

    public void do_command(int comm) {
	switch (comm) {
	case 0:       // (sw)curve 1
	    ES = !ES;
	    intw(getacent());
	    break;
	case 1:       // (sw)pitch 2
	    PS = !PS;
	    ch_pitch();
	    break;
	case 2:       // (sw)chord 3
	    ch_chord();
	    break;
	case 3:       // (sw)stress 4
	    SS = !SS;
	    break;
	case 4:       // (sw)face 5
	    GU = !GU;
	    break;
	case 5:       // (sw)cent.txt 6
	    CC = !CC; // cent_data all or wide
	    break;
	case 6:        // (sw)partial
	    PA = !PA;
	    break;
	default:
	}
    }

    public void disp_sw() {
	if (VS)
            re_write();     // text
        else 
	    can.repaint();  // graph.
    }
    public int getInterval() {
	return I.getIvalue(Inum);
    }
    public int getMaxkey() {
        return AW-1;
    }
    public int getMinkey() {
        return FB;
    }
    public void set_ih() {
	if (!(INH == IHL || INH == IHN) && Vsw == INHA)
	    Vsw = INTE;

	btV[3].setEnabled((INH == IHL || INH == IHN)); // inharmo.
    }
    public void set_ratio() {
	int val = getInterval();
	BW = TT.nextKey(WN, Rev ? val : -val);
	int max = getMaxkey();
        int min = getMinkey();

	if (BW >= max)
	    BW = max;
       	if (BW < min)
	    BW = min;

	WN = TT.nextKey(BW, Rev ? -val : val);
	dispinter();
    }
    public void changeKey() {
	int iv = getInterval();
	changeKey(iv);
    }
    public void changeKey(int x) {
	set_ratio();

	WN = TT.nextKey(WN, Rev ? -x : x);
	int max = getMaxkey();
	int min = getMinkey();

	if (WN >= max)
	    WN = max;
	else if (WN < min)
	    WN = min;

	setBaseWire();
    }
    public void setBaseWire() {
	BW = TT.nextKey(WN, Rev ? getInterval() : -getInterval());
    }
    public void reversKey() {
	Rev = !Rev;

	btKeys[0].setLabel(Rev ? "<-" : "->");
        btKeys[1].setLabel(Rev ? "<" : ">");
        btKeys[2].setLabel(Rev ? "<<" : ">>");

	int tmp = BW;
	BW = WN;
	WN = tmp;
    }
    public boolean is5(int num) {
	int i = 1;
	while (Imax > i) {
	    if (num == 5*i)
		return true;
	    else
		i *= 10;
	}
	return false;
    }
    public void setGain(boolean sw) {
	switch (Vsw) {
	case INTE:
	    Ix = is5(Ix) ? (sw ? Ix*2 : Ix/5) : (sw ? Ix*5 : Ix/2);
	    if (Ix > Imax)
		Ix = Imax;
	    else if (Ix < 1)
		Ix = 1;
	    break;
	case BEAT:
	    int bx = 10;
	    int bn = 1;
	    Bb = sw ? ++Bb : --Bb;
	    if (Bb > bx)
		Bb = bx;
	    else if (Bb < bn)
		Bb = bn;
	    break;
	case WIRE:
	    double l2 = Math.log(2);
	    Lmax = sw ? (int)(Lmax*l2) : (int)(Lmax/l2);
	    if (Lmax > 10000)
		Lmax = 10000;
	    if (Lmax < 2000)
		Lmax = 2000;
	    break;
	default:
	    int cx = 200;  // cent max.
	    int cn = 10;   // cent min. 
	    Cmax = sw ? Cmax*2 : Cmax/2;
	    Bmax = sw ? Bmax*2 : Bmax/2;
	    if (Cmax > cx)
                Cmax = cn;
            if (Cmax > 26 && Cmax < 50)
                Cmax = 50;
            if (Cmax < 26 && Cmax > 10)
                Cmax = 20;
            if (Cmax < cn)
                Cmax = cx;

	    Bmax = Cmax/5;
	    DH = (double)(H-1)/Cmax;
	}
    }   
    public void setInterval() {
	LY = sbL.getValue()/10.0;
	OV = sbO.getValue()/100.0;
	dispinter();
    }
    public void dispinter() {
	lCent.setText("Laying:"+LY);
	lBeat.setText("Interval:"+OV);
    }
    //---
    public void run() {
	int stime = 90;
	try {
            while (TT.isRun()) {
		disp_sw();
                thr.sleep(stime);
            }
        } catch (InterruptedException e) {
            System.out.println(e);
        }

	Tsw = NOT;
	disp_sw();
    }
    public double getInhar(int wn) {
	return TT.getInhar(wn);
    }
    public double getInha(int wn) {
	return TT.getInha(wn);
    }
    public double getInha(int wn, int pr) {
	return TT.getInha(wn, pr);
    }
    public double getacent() {
        return MC*Math.log(Aa/AA);
    }
    public double get_cent(int wn) {
	return TT.getCent(wn);
    }
    public double get_icent(int wn, int pr) {
	return TT.getIcent(wn, pr);
    }
    public double get_freq(int wn) {
	return TT.getFreq(wn);
    }
    public double get_ifreq(int wn, int pr) {
	return TT.getIfreq(wn, pr);
    }
    public void add_cent(int wn, double ce) {
	TT.addCent(wn, ce);
    }
    public void set_cent(int wn, double ce) {
	TT.setCent(wn, ce);
    }
    public boolean isLength(int wn) {
	return TT.isLength(wn);
    }
    public double getLength(int wn) {
	return TT.getLength(wn);
    }
    public double getDensity(int wn) { // debug
	return TT.getDensity(wn);
    }
    public double getGtension(int wn) {
	return TT.getGtension(wn);
    }
    public double getStress(int wn) {
	return TT.getStress(wn);
    }
    public double getGauge(int wn) {
	return TT.getGauge(wn);
    }
    public double getBinhar(int wn, int pa) {
	return TT.getBinhar(wn, pa);
    }
    public double getB(int wn) {
	return TT.getB(wn);
    }
    public String getS(int wn) {
	return TT.toString(wn);
    }
    public int[] getHeader() {
	return TT.getHeader();
    }
    public boolean isCopper(int wn) {
	return TT.isCopper(wn);
    }
    public int wtok(int wn) { // 0~->1~
        return TT.getW2K(wn);
    }
    public int ktow(int k) { // 1~88->0~
        return TT.getK2W(k);
    }
    public void set_icent(int wn, double ce) {
	if (ES)
	    tune_cent(wn, ce);
	else
	    set_cent(wn, ce);
    }
    public void tune_cent(int wn, double ce) {
	double dif = 0.001;
	int kn = wtok(wn)-1;
	set_cent(wn, Cdata[kn]+ce-getInha(wn));

	while (get_icent(wn,1) > Cdata[kn])
	    add_cent(wn, -dif);
	while (get_icent(wn,1) < Cdata[kn])
	    add_cent(wn, dif);
    }
    //
    public double ctof(double f, double cent) { // cent to hz
	return f*Math.pow(2, cent/Cent);
    }
    public double log_base(double value) {
	return Math.log(value)/Math.log(10);
    }
    public double log_base(double base, double value) {
	return Math.log(value)/Math.log(base);
    }

    public void re_write() {
	switch (Vsw) {
	case BEAT:
	    write_beats();
	    break;
	case LAYY: 
	    write_lay();
	    break;
	case CENT:
	    if (CC)  // cent.txt sw.
		write_cent();
	    break;
	case INTE:
	case INHA:
	case WIRE:
	case SEPA:
	    write_text();
	    break;
	case DATA:
	    write_data();
	    break;
	default:
	}
	write_tf();
    } 
    public void write_data() {
	StringBuffer str = new StringBuffer(1024);
	String bar = "---------------------\n";
	str.append(Dfiles[Dsel]);
	switch (Dsel) {
	case DWIRE: // wire
	    str.append("<");
	    str.append(Filenm[File]+">\n");
	    str.append(bar);
	    str.append(write_wire_name());
	    break;
	case DCENT: // cent
	    str.append("<");
	    if (Cnum >= 0)
		str.append(Datanm[Cnum]);
	    str.append(">\n");
	    str.append(bar);
	    str.append(write_cent_name());
	    break;
	case DTMPF: // temp. file
	    str.append("<");
	    str.append(Tempnm[Tname]+">\n");
	    str.append(bar);
	    str.append(write_temp_name());
	    break;
	case DTMPD: // temp. data
	    str.append("\n");
	    str.append(bar);
	    str.append(Swork);
	    break;
	default:
	}
	taA.setText(str.toString());
    }
    public String write_wire_name() {
	StringBuffer str = new StringBuffer(1024);
	str.append(TT.getHeaderS());
	for (int i = 0; i < AW; i++)
	    str.append(getS(i));

	return str.toString();
    }
    public String write_temp_name() {
	StringBuffer str = new StringBuffer(1024);
	for (int i = 0; i < Tnum; i++)
	    str.append(getTempName(i)+"\n");

	return str.toString();
    }
    public String write_cent_name() {
	StringBuffer str = new StringBuffer(1024);
	for (int i = 0; i < KB; i++)
	    str.append(Cdata[i]+"\n");

	return str.toString();
    }
    public void write_cent() { // for save .cdf
	StringBuffer str = new StringBuffer(1024);
	str.append(Filenm[File]+"\n");
	int[] head = TT.getHeader();
	int ob = head[0]; // single wound end
	int db = head[1]; // w wound end

	for (int i = 0; i < AW; i++) {
	    if (i < FB) {         // FBʲ0
		str.append("0,");
		continue;
	    }
	    if (i > ob && i < db)
		i++;
	    str.append(dform(get_icent(i,1)));
	    str.append((wtok(i)%11 == 0) ? "\n" : ",");
	}
	str.append("\n");

	taA.setText(str.toString());
    }
    public void write_text() {
	StringBuffer str = new StringBuffer(1024);
	str.append(Head1);

	switch(Vsw){
	case CENT:
	    str.append("Cent");
	    if (PA) {
		str.append(" 1");
		for (int j = 2; j <= 12; j++)
		    str.append(" : "+j);
	    }
	    str.append("\n");
	    break;
	case INHA:
	    if (INH == IHN)
		str.append("   B   :");
	    str.append("Inharmo.");
	    if (PART > 1) {
		str.append(" 1");
		for (int i = 2; i <= PART; i++)
		    str.append(" : "+i);
	    }
	    str.append("\n");
	    break;
	case WIRE:
	    str.append("Length[mm]: ");
	    str.append("Gauge("+(TT.isPiano() ? "[mm]" : "#")+"): ");
	    str.append("Tension(G)[kgf]");
	    if (SS)
		str.append(": Stress[kgf/mm^2]");
	    str.append("\n");
	    break;
	case INTE:
	    str.append(I.toString(Inum)+"\n");
	    break;
	case SEPA:
	    str.append("[cent]\n");
	    break;
	default:
	    str.append("\n");
	}

	str.append("----------------------------------\n");
	int ii, nw;
	int[] id = I.getIdata(Inum);                          // for INTE
	int[] keys = get_minmaxKey(id[2], getMinkey(), getMaxkey()); // "
	outer:
	for (int i = 0; i < ENDW; i++) {
	    ii = i+START;
	    if (isLength(ii))
                continue;

	    str.append(get_wire_key(ii));
	    switch(Vsw){
	    case CENT:
		str.append(df_form(get_icent(ii, 1)));
		if (PA) {
		    for (int j = 2; j <= 12; j++)
			str.append(df_form(get_icent(ii,j)));
		}
		break;
	    case INHA:
		if (INH == IHN)
		    str.append(" : ").append(dform2(getB(ii)));
		for (int j = 1; j <= PART; j++)
		    str.append(df_form(getInha(ii,j)));
		break;
	    case WIRE:
		str.append(df_form(getLength(ii)));
		str.append(df_form(getGauge(ii)));
		str.append(df_form(getGtension(ii)));
		if (SS)
		    str.append(df_form(getStress(ii)));
		break;
	    case INTE:
		if (ii >= keys[0] && ii <= keys[1]) {
		    nw = TT.nextKey(ii, (Rev ? id[2] : -id[2]));
		    str.append(df_form(get_full_beats(ii, nw, id)));
		} else
		    str.append(": *");
		break;
	    case SEPA:
		//if (ii >= KB)
		//  continue;
		str.append(df_form(get_icent(ii, 1)));
		break;
	    default:
	    }
	    str.append("\n");
	}
	taA.setText(str.toString());
    }
    public void write_lay() {
	StringBuffer str = new StringBuffer(1024);
	str.append(Head1).append("[cent] : ");
	str.append(I.toString(Inum)).append(" : P4th : P5th\n");
	str.append("-----------------------------------------\n");
	int stt = TT.nextKey(BW, -MJ3);
	if (wtok(stt) == wtok(stt-1)) // 2ξ
	    stt--;                    // run()Ʊ
	if (stt < FB)  //
	    stt = FB;
	else if (stt > AW-OCT)
	    stt = AW-OCT-1; //
	    
	int wn, oct = TT.nextKey(stt, OCT); // octb?
	for (int i = 0; i <= oct-stt; i++) {
	    wn = stt+i;
	    if (wn >= AW)
		break;
	    if (isLength(wn))
		continue;

	    str.append(get_wire_key(wn));
	    str.append(df_form(get_icent(wn, 1)));
	    if (wn+I.getIvalue(Inum) < AW)
		str.append(write_b(wn, Inum));

	    if (wn+I.getIvalue(P4th) < AW && TT.nextKey(wn, I.getIvalue(P4th)) <= oct)
		str.append(write_b(wn, P4th));
	   
	    if (wn+I.getIvalue(P5th) < AW && TT.nextKey(wn, I.getIvalue(P5th)) <= oct)
		str.append(write_b(wn, P5th));
	    str.append("\n");
	}

	taA.setText(str.toString());
    }
    public String write_b(int w, int r) {
	int nk = TT.nextKey(w, I.getIvalue(r));

	if (isLength(nk))
	    return ": -----";
	else {
	    Inter i = new Inter(w, nk, r);
	    return df_form(TT.getBeats(i));
	}
    }
    public void write_beats() {
	StringBuffer str = new StringBuffer(1024);
	int r, sck;
	double ih;
	calc_beats();
	str.append("P#:      [Hz] :  Inhar. : ");
      	str.append(getInterval());
	str.append("(beats) : ( Key# : [cent] )\n");
	str.append("-----------------------\n");
	if (!isLength(WN) && !isLength(BW)) {
	    for (int i = 0; i < Prt; i++) { // rev.
		r = Prt-i;
		str.append(r);
		ih = get_ifreq(WN, r);
		str.append(df_form(ih));
		str.append(df_form(getInha(WN, r)));
		str.append(df_form(Unari[r])).append(": ( ");
		sck = ftok(ih);
		str.append(1+sck);
		str.append(get_keyname(sck));
		str.append(df_form(f2c(sck, ih))).append(" )\n");
	    }
	} else
	    str.append("-----");

	taA.setText(str.toString());
    }
    public String df_form(double val) {
	return ": "+dform(val);
    }
    public String dform0(double val) {
	return df0.format((float)val);
    }
    public String dform(double val) {
	return df1.format((float)val);
    }
    public String dform2(double val) {
	return df2.format((float)val);
    }
    public double f2c(int keyn, double f) {
	return MC*Math.log(f/getFreq(keyn));
    }
    public int ftok(double sf) {
	int key = (int)Math.rint(OCT*log_base(2, sf/getFreq(0)));
        if (key < 0)
            key = 0;
        else if (key >= KA)
            key = KA-1;
        return key;
    }
    public String get_keyname(int k) {
	return keynm[k%OCT];
    }
    //-----

    class MyCanvas extends Canvas {
	private static final long serialVersionUID = 1L;

        public void update(Graphics g) {
            can.paint(g);
        }
	public void paint(Graphics g) {
	    paintI();
	    g.drawImage(im, 0, 0, this);
	}
    }
    public void paintI() {
	gi.setColor(Color.black);
	gi.fillRect(0, 0, W, H);
	set_init();

	switch(Vsw){
	case CENT:
	    disp_aline(gi);
	    disp_scale(gi);
	    disp_curve(gi);
	    if (PA)
		disp_partial(gi);
	    displabel(gi);
	    break;
	case BEAT:
	    disp_beats(gi);
	    break;
	case INTE:
	    disp_aline(gi);
	    disp_interval(gi);
	    displabel(gi);
	    break;
	case INHA:
	    int hb = H/6; // log
	    disp_aline(gi);
	    disp_log(gi, hb);
	    disp_inh(gi, hb);
	    displabel(gi);
	    break;
	case WIRE:
	    disp_wire(gi);
	    disp_ten(gi);
	    if (SS)
		disp_strees(gi);
	    break;
	case LAYY:
	    disp_lay(gi);
	    break;
	case SEPA:
	    set_sepkey();
	    disp_separate(gi);
	    break;
	case DATA:
	    disp_data(gi);
	    break;
	default:
	}
	write_tf();
	disp_tuning(gi);
    }
    public void set_init() {
	TD = (double)(W-1)/Tmax;     // ĥñ
	BD = (double)(W-1)/Lmax;     // 縹Ĺmm
    }
    public void disp_data(Graphics g) {
	boolean sw;
	for (int i = 0; i < Dfiles.length; i++) {
	    sw = !(Dsel == i);
	    g.setColor(Color.gray);
	    g.fill3DRect(rdat[i].x, rdat[i].y, rdat[i].width, rdat[i].height, sw);

	    g.setColor(Color.red);
	    g.drawString(Dfiles[i], rdat[i].x+4, rdat[i].y+FNT);
	}
	switch (Dsel) {
	case DWIRE:  // wire
	    disp_data_name(g, Filenm);
	    break;
	case DCENT:  // cent
	    disp_data_name(g, Datanm);
	    break;
	case DTMPF:  // temp. file
	    disp_data_name(g, Tempnm);
	    break;
	case DTMPD:  // temp. data
	    disp_data_name(g);
	    break;
	default:
	}
	disp_go_button(g);
    }
    public void disp_data_name(Graphics g) {
	String[] st = new String[Tnum];
	for (int i = 0; i < Tnum; i++)
	    st[i] = getTempName(i);
	disp_data_name(g, st);
    }
    public void disp_data_name(Graphics g, String[] dt) {
	int max = (H-10)/RH;
	int xn = get_maxlength(dt);           // ʸκͤ
	int wl = fm.stringWidth(dt[xn]+"00"); // ʸ

	if (dt.length > max)  // ̥ϥ߽Х
	    pm_button(g, dt.length, max);
	else
	    Dstt = 0;

	if (Dnum >= dt.length)
	    Dnum = dt.length-1;

	set_rlist(dt.length-Dstt, RW+40, 10, wl); // ꥹȰֺ
	boolean sw;
	for (int i = 0; i < dt.length-Dstt; i++) {
	    sw = !(Dnum == i);
	    g.setColor(Color.gray);
	    g.fill3DRect(rlist[i].x, rlist[i].y, rlist[i].width, rlist[i].height, sw);

	    g.setColor(Color.yellow);
	    g.drawString(dt[i+Dstt], rlist[i].x+5, rlist[i].y+FNT);  
	}
    }
    public void pm_button(Graphics g, int ln, int mx) {
       	if (!RP)
	    Dstt += mx;
	else if (!RM)
	    Dstt -= mx;

	if (Dstt < 0)  // ѿΰ
	    Dstt = 0;
	else if (Dstt >= ln)
	    Dstt = ln-mx;

	if (ln-Dstt <= mx)
	    disp_pm_button(g, Rm, "-");
	else if (Dstt == 0)
	    disp_pm_button(g, Rp, "+");
	else {
	    disp_pm_button(g, Rp, "+");
	    disp_pm_button(g, Rm, "-");
	} 
    }
    public void disp_pm_button(Graphics g, Rectangle r, String s) {
	g.setColor(Color.gray);
	g.fill3DRect(r.x, r.y, r.width, r.height, true);

	g.setColor(Color.pink);
	g.drawString(s, r.x+10, r.y+FNT);
    }
    public void disp_go_button(Graphics g) {
	g.setColor(Color.gray);
	g.fill3DRect(Select.x, Select.y, Select.width, Select.height, SLCT);

	g.setColor(Color.white);
	g.drawString(Sel_btn, Select.x+3, Select.y+FNT);

	int num = Dnum+Dstt;
	if (!SLCT) {       // rev. for 3D
	    switch (Dsel) {
	    case DWIRE:  // wire
		File = num;
		read_wire(Filenm[File]);
		break;
	    case DCENT:  // cent
		Cnum = num;
		read_cent(Cnum);
		break;
	    case DTMPF:  // temp. file
		Tname = num;
		read_tempf(Tname);
		set_temper();
		break;
	    case DTMPD:  // temp. data
		set_temp_work(num);
		set_temper();
		break;
	    default:
	    }
	}
    }

    public void disp_partial(Graphics g) {
	int p ,x, ii;
	Color c;
	for (int i = 0; i < ENDW; i++) {
	    ii = i+START;

	    if (ENDW < Knmax)
		disp_knm(i, g);
	    if (isLength(ii))
		continue;
	   
	    p = get_partial(ii);
	    c = check_key(wtok(ii)-1);

	    x = get_dx(i);
	    for(int j = 1; j <= 12; j++) { // 12ܲޤ
		g.setColor((ii == BW) ? C0 : (p == j) ? c : Color.gray);
		g.fillOval(x, get_dh(get_icent(ii,j)*DH), Dot, Dot);
	    }	    
	}
    }
    public int get_partial(int w) {
	TT.setSepKey(SEP, SEPKEY);
	int p, in = TT.get_intr(w);

	if (w > TT.nextKey(BW, MI6)) //
	    p = I.getIhigh(in);
	else if (w < TT.nextKey(BW, -MJ3)) //
	    p = I.getIlow(in);
	else
	    p = 1;

 	return p;
    }

    public void set_keyboard() {
	for (int i = 0; i < KB; i++)
            K[i] = new Keyboard(0, 50, 'A', false);
    }
    public void set_keyboard_max() {
	double val = W/K[0].getMaxX();
	for (int i = 0; i < KB; i++)
	    K[i].setValue(val);
    }
    public void disp_separate(Graphics g) {
	int i, j;
	int bw = wtok(BW);
	int xx = (int)K[bw-1].getX();
	g.setColor(C0);               // 
	g.drawString(bw+"<"+get_keyname(bw-1)+">",xx, FNT*2);

	int keymax = wtok(AW-1);      // 꿶ϰ
	int kmin = (bw-MJ3 <= FB) ? FB+1 : bw-MJ3;
	int kmax = (bw+MI6 > keymax) ? keymax : bw+MI6;
	g.setColor(Color.white);
	g.drawString("[ "+kmin+"..."+kmax+" ]",(int)K[kmin].getX(), FNT*3);

	for (i = 0; i < KB; i++) { // keyboard disp.
	    if ((i < keymax && isLength(i)) || i >= keymax)
		g.setColor(Color.black);
	    else
		g.setColor( check_key(i) );
	    g.fillPolygon(K[i].getPoly());

	    g.setColor(Color.gray);
            g.drawPolygon(K[i].getPoly());
	}

	g.setColor(Color.white);
	for (i = 0; i < sepa.length; i++)  // ʬϰ ɽ
	    g.drawString(Sep_key[i], sepa[i][0].x-20, HH-FNT);

	for (i = 0; i < sepa.length; i++) {   // buttons
	    for (j = 0; j < sepa[0].length; j++) {   // scope
		g.setColor((SEPAR[j] == SEP[i]) ? Cs[i] : Color.lightGray);
		g.fill3DRect(sepa[i][j].x, sepa[i][j].y, 
			     sepa[i][j].width, sepa[i][j].height, 
			     (SEPAR[j] == SEP[i]) ? true : false);

		g.setColor(Color.white);
		g.drawString(sep[j], sepa[i][j].x+6, sepa[i][j].y+FNT);
	    }
	}
    }
    public Color check_key(int k) {
	Color c;
	int bk = wtok(BW);
	if (k == bk)
	    c = C0;
	else if (k >= bk-MJ3 && k <= bk+MI6)
	    c = Color.white;
	else if (k < SEPKEY[1])
	    c = Cs[0];
	else if (k < SEPKEY[2])
	    c = Cs[1];
	else if (k < SEPKEY[3])
	    c = Cs[2];
	else if (k < SEPKEY[4])
	    c = Cs[3];
	else 
	    c = Cs[4];
	return c;
    }
    public void disp_tuning(Graphics g) {
	if (Tsw == NOT || Tsw == FRM)
	    return;

	int fh = fm.getHeight();
	int fw = fm.stringWidth(tun[Tsw]);
	int x = (W-fw)/2;
	int y = fh*2;
	g.setColor(Color.gray);
	g.fill3DRect(x-2, y-fh, fw+4, fh+4, false);
	
	g.setColor(Color.cyan);
	g.drawString(tun[Tsw], x, y-2);
    }
    public void disp_lay(Graphics g) {
	String head0 = Head1+"    [cent]:    ";
	String head2 = ":     P4th:         P5th:    (P4th):    (P5th)";
	String line = "--------------------------------------------------------------";
	int stx = 10, sty = FNT, yt = FNT;
	int stt = TT.nextKey(BW, -MJ3);
	if (wtok(stt) == wtok(stt-1)) // 2ξ
	    stt--;                    // run()Ʊ
	if (stt < FB)  //
	    stt = FB;
	else if (stt > AW-OCT)
	    stt = AW-OCT-1; //

	g.setColor(Color.yellow);
	g.drawString(head0+getInterval()+head2, stx, sty);
	sty += yt;
	g.drawString(line, stx, sty);
	sty += yt;
	int sy, wn, oct = TT.nextKey(stt, OCT); // octb?
	for (int i = 0; i <= oct-stt; i++) {
	    sy = sty+i*yt;
	    wn = stt+i;
	    if (mY < sy && mY > sy-yt)
		WN = wn;
	}

	int kn, sx = fm.stringWidth("0000.0000");
	for (int i = 0; i <= oct-stt; i++) {
	    sy = sty+i*yt;
	    wn = stt+i;
	    if (wn >= AW)
		break;
	    if (isLength(wn))
		continue;

	    g.setColor(Color.white);
	    set_color(g, wn);
	    g.drawString(get_wire_key(wn), stx, sy);
	    g.drawString(dform(get_icent(wn, 1)), stx+sx*2, sy);

	    if (wn+I.getIvalue(Inum) < AW)
		disp_b(g, wn, Inum, stx, sx, 3, sy, false);

	    if (wn+I.getIvalue(P4th) < AW && TT.nextKey(wn, I.getIvalue(P4th)) <= oct)
		disp_b(g, wn, P4th, stx, sx, 4, sy, true);
	    
	    if (wn+I.getIvalue(P5th) < AW && TT.nextKey(wn, I.getIvalue(P5th)) <= oct)
		disp_b(g, wn, P5th, stx, sx, 5, sy, true);
	}
    }
    public void disp_b(Graphics g, int w, int r, int t, 
		       int x, int xx, int y, boolean sw) {
	int by = 10;
	x -= 5;
	int nk = TT.nextKey(w, I.getIvalue(r));

	g.setColor(Color.white);
	if (isLength(nk))
	    g.drawString("---", t+x*xx, y);
	else {
	    Inter i = new Inter(w, nk, r);
	    double b = TT.getBeats(i);
	    g.drawString(dform(b), t+x*xx, y);

	    if (sw) {
		g.setColor((b > 0) ? Color.orange : Color.cyan);
		g.fillRect(t+x*(xx+2), y-10, (int)Math.abs(b*by), 5);
	    }
	}
    }

    public void disp_iline(Graphics g, double h) {
	double hx = Ix/5.0, hi, hh;
	int xs = 2, hp, hm;

        for (int i = 1; i < 6; i++) { // scale line
	    hi = hx*i;
	    hh = h*hi;
            hp = (int)(HH+hh);
	    hm = (int)(HH-hh);

            g.setColor(Color.blue);
            g.drawLine(0, hm, W-1, hm);
            g.drawLine(0, hp, W-1, hp);

            g.setColor(Color.lightGray);
            g.drawString(dform(hi),  xs, hm+FNT);
            g.drawString("-"+dform(hi), xs+2, hp);
        }

        g.setColor(Color.gray);  // center line
        g.drawLine(0, HH, W-1, HH);
    }
    public void disp_interval(Graphics g) {
	double Umax = -1000;
	double Umin = 1000;
	double be, hi = H/(double)(Ix*2);
	int[] id = I.getIdata(Inum);
	int[] keys = get_minmaxKey(id[2], getMinkey(), getMaxkey());

	disp_iline(g, hi);

	int ii, nw;
	for (int i = 0; i < ENDW; i++) {
	    ii = i+START;
  	    if (ENDW < Knmax)
		disp_knm(i, g);

	    g.setColor(Ci);
	    set_color(g, ii);
	    if (ii >= keys[0] && ii <= keys[1]) {
		nw = TT.nextKey(ii, (Rev ? id[2] : -id[2]));
		if (isLength(ii) || isLength(nw))
		    continue;

		be = get_full_beats(ii, nw, id);
		if (Umax < be)
		    Umax = be;
		if (Umin > be)
		    Umin = be;
		g.fillOval(get_dx(i), get_dh(be*hi), Dot, Dot);
	    } else   // intervalѥʬ
		g.drawOval(get_dx(i), get_dh(0), Dot, Dot);
	}

	String mx = "max:"+dform(Umax);
	int xl = fm.stringWidth(mx);
	String mi = "min:"+dform(Umin);
	int il = fm.stringWidth(mi);
	g.setColor(Color.red);
	g.drawString(mx, W-xl, FNT*2);
	g.drawString(mi, W-il, FNT*3);
    }
    public double get_full_beats(int k, int nk, int[] id) {
	if (Rev)
	    return get_ifreq(k, id[0])-get_ifreq(nk, id[1]);
	else
	    return get_ifreq(k, id[1])-get_ifreq(nk, id[0]);
    }
    public int[] get_minmaxKey(int itv, int min, int max) {
        int[] key = new int[2];

        key[0] = Rev ? min : TT.nextKey(min, itv);
        key[1] = Rev ? TT.nextKey(max, -itv) : max;

        return key;
    }
    public void disp_beats(Graphics g) {
	int ws = fm.stringWidth("20:0000000.000");
	int hs = 20, hh = H-hs, ww = W-ws;
	double dh = hh/(double)Pmax;
	double db = ww/(double)Bby;

	g.setColor(Color.blue);
	g.drawLine(ws, hs, ws, hh); // v line
	g.drawLine(0, hh, W-1, hh); // h line

	int dx, ml;
	for (int i = 0; i < Bby; i++) { // memori
	    dx = (int)(ws+i*db);	   
	    ml = get_memori(g, i);
	    if (ml > 0)
		g.drawLine(dx, hh+1, dx, hh+ml);
	}

	String nw = "-----";
	int knl, ss = hh+FNT+2;
	g.setColor(Color.green);
	if (isLength(WN)) {
	    knl = fm.stringWidth(nw);
	    g.drawString(nw, 3, ss);
	} else {
	    String kn = "#"+get_wire_key(WN)+"[Hz]";
	    knl = fm.stringWidth(kn);
	    g.drawString(kn, 3, ss);
	}

	g.setColor(Color.magenta);
	g.drawString(isLength(BW) ? nw : "#"+get_wire_key(BW)+"[Hz]",
		     knl+5, ss);

	if (isLength(WN) || isLength(BW))
	    return;

	set_rbeat(hh, ws, dh);  
	calc_beats();

	int di, ba;
	for (int i = 1; i <= Pmax; i++) { // Prt
	    di = (int)(hh-dh*(i-1)-2); // -3
	    if (i <= Prt) {
		ba = (int)(db*Unari[i]);
		if (ba > ww)
		    ba = ww;

		g.setColor(Cn);
		g.drawString(i+df_form(Unari[i]),1, di);
 
		g.setColor(Cb);
		g.fillRect(ws, di-Bb, ba, Bb);
	    } else {
		g.setColor(Cn);
		g.drawLine(1, di, 1, (int)(di-dh-3));
	    }
	}
    }
    public int get_memori(Graphics g, int i) {
	int ml = -1;
	if (i%10000 == 0) {
	    ml = 17;
	    g.setColor(Color.gray);
	} else if (Bby < 50000 && i%1000 == 0) {
	    ml = 15;
	    g.setColor(Color.lightGray);
	} else if (Bby < 10000 && i%100 == 0) {
	    ml = 13;
	    g.setColor(Color.white);
	} else if (Bby < 2000 && i%10 == 0) {
	    ml = 10;
	    g.setColor(Color.lightGray);
	} else if(Bby < 500 && i%5 == 0) {
	    ml = 7;
	    g.setColor(Color.lightGray);
	} else if (Bby < 100) {
	    ml = 5;
	    g.setColor(Color.gray);
	}
	return ml;
    }
    public void calc_beats() {
	double by = getFreq(WN)/getFreq(BW);
	double big = Integer.MAX_VALUE;
	int i;

	if (by < 1)
	    by = 1/by;
	int p = (int)by;
	p = (p > Pmax) ? p*2 : Prt;

	double[] Bgf = new double[p+1];
	double[] Slf = new double[p+1];
	Unari = new double[p+1];
	
	for (i = 1; i <= p; i++) {
	    Slf[i] = get_ifreq(BW, i);
	    Bgf[i] = get_ifreq(WN, i);
	}
	Bmin = big;  // min beats
	double max, una;
 	for (i = 1; i <= p; i++) {
	    max = big;
	    for (int j = 1; j <= p; j++) {
		una = Math.abs(Bgf[i]-Slf[j]);
		if (max > una)
		    max = una;
		if (Bmin > max) {
		    Bmin = max;
		    MP = i;
		}
	    }
	    Unari[i] = max;
	}
    }
    public void dispBeats(Graphics g, int x) {
	calc_beats();
	int vol = (int)(Bmin*H/(double)Bmax);
	if (vol > H+1)
	    vol = H+1;
	g.setColor(Cb);
	g.drawRect(get_dx(x), H-vol, Dot, vol-1);
    }

    public void write_tf() {
	String s = "";

	if (!Error.equals(""))
	    s = Error;
	else if (isLength(WN))
	    s = "-----";
	else {
	    switch(Vsw){
	    case CENT:
		s = dform(Bmin)+" P:"+MP;
		break;
	    case BEAT:
		s = "P:"+MP;
		break;
	    case INTE:
		int[] id = I.getIdata(Inum);
		int[] keys = get_minmaxKey(id[2], getMinkey(), getMaxkey());
		if (WN >= keys[0] && WN <= keys[1]) {
		    int nw = TT.nextKey(WN, (Rev ? id[2] : -id[2]));
		    s = "B:"+dform(get_full_beats(WN, nw, id));
		} else
		    s = "B:*";
		break;
	    case INHA:
		s = "I:"+dform(getInha(WN))+"[cent]";
		break;
	    case WIRE:
		s = "W:"+dform(getLength(WN))+"[mm]";
		break;
	    case LAYY:
		s = "L:#"+(BW+1);
		break;
	    case SEPA:
		int k = wtok(BW);
		s = "S:"+k+"<"+get_keyname(k-1)+">";
		break;
	    case DATA:
		switch (Dsel) {
		case DTMPF:
		case DTMPD:
		case DWIRE:  // wire
		    s = "D:"+((File >= 0) ? Filenm[File] : "___");
		    break;
		case DCENT:  // cent
		    s = "D:"+((Cnum >= 0) ? Datanm[Cnum] : "___");
		    break;
		default:
		    s = "D: ?";
		}
		break;
	    default:
		s = "___";
	    }

	    if (VS && Vsw == CENT && ES && !Fname.equals(""))
		s = "from "+Fname;
	    else if (isFile())
		s = get_wn_text(s);
	}

	tfA.setText(s);
    }
    public String get_wn_text(String st) {
	StringBuffer str = new StringBuffer(48);

	str.append("#"+get_wire_key(WN));
	str.append("[").append(dform(get_icent(WN,1)));
	str.append("] ").append(st).append(" (");
	str.append(I.getIinter(wtok(BW)-wtok(WN))).append(")");

	return str.toString();
    }
    public String get_wire_key(int wn) {
	if (!isFile())
	    return "";

	StringBuffer str = new StringBuffer(48);
	int kn = wtok(wn);
	str.append((wn+1)+":"+kn+"(");
	str.append(get_keyname(kn-1)+")");
	str.append(dform(get_ifreq(wn,1)));
	
	return str.toString();
    }
    
    public void displabel(Graphics g) {
	g.setColor(Color.magenta);
	g.drawString("#"+get_wire_key(BW), FNT*3, FNT*2);
    }
    
    public void disp_knm(int kn, Graphics g) {
	int k = (wtok(kn+START)-1)%OCT;
       
        g.setColor((k == 1 || k == 4 || k == 6 || k == 9 || k == 11) ? 
                    Color.gray : Color.white);
        g.drawString(get_keyname(k), (int)(WD*kn), FNT);
    }

    public void disp_curve(Graphics g) {
	String bx = "Beats max:"+Bmax;
	int bl = fm.stringWidth(bx), ii;
	g.setColor(Color.red);
	g.drawString(bx, W-bl, FNT*2);

        for (int i = 0; i < ENDW; i++) {
	    ii = i+START;

	    if (ENDW < Knmax)
		disp_knm(i, g);
	    if (isLength(ii))
                continue;

	    g.setColor(getWireColor(ii));
	    if (ii == BW && ii == WN) {
		dispBeats(g, i);   // get beats
		g.setColor(C0);
	    } else if (ii == WN) {
		dispBeats(g, i);   // get beats
		g.setColor(Cn);    // now wire
	    } else if (ii == BW)
		g.setColor(C0);

	    g.fillOval(get_dx(i), get_dh(get_icent(ii,1)*DH), Dot, Dot);
	}
    }
    public Color getWireColor(int wn) {
	return isCopper(wn) ? Cc : Cw;
    }
    public void disp_scale(Graphics g) {
        int hx = Cmax/10;
	int xs = 2, hp, hm, hi;
	double hy;

        for (int i = 1; i < 6; i++) { // scale line
	    hi = hx*i;
            hy = DH*hi;
	    hp = (int)(HH+hy);
	    hm = (int)(HH-hy);

            g.setColor(Color.blue);
            g.drawLine(0, hm, W-1, hm);
            g.drawLine(0, hp, W-1, hp);

            g.setColor(Color.yellow);
            g.drawString(String.valueOf(hi), xs+2, hm+FNT);
            g.drawString("-"+hi, xs, hp);
        }

        g.setColor(Color.gray);  // center line
        g.drawLine(0, HH, W-1, HH);
    }
    public void disp_aline(Graphics g) {
	int ii, kn, wi;
        for (int i = 0; i < ENDW; i++) {
	    ii = i+START;
	    kn = wtok(ii); 
            if (kn % OCT == 1) {  // akeyľ
		wi = (int)(WS+WD*i);

                g.setColor(Color.blue);
		g.drawLine(wi, 0, wi, H-2);
 
                g.setColor(Color.red); // octav name
                if (kn > 84)
                    wi -= OCT;
                g.drawString(octnm[kn/OCT], wi, H-6);
            }
        }
    }

    public void disp_log(Graphics g, int hb) {
        double h0 = 0.001, hl;
	int hv, hm;

        for (int i = 1; i < 6; i++) { // ʿ
	    hl = h0*Math.pow(10, i);
	    hm = (int)(HH-hb*log_base(hl));

            g.setColor(Color.blue);
            g.drawLine(0, hm, W-1, hm);

            g.setColor(Color.orange); // 
            g.drawString(String.valueOf((float)hl), 2, hm);
        }
    }
    public void disp_inh(Graphics g, int hb) {
	int ii, x;
        for (int i = 0; i < ENDW; i++) {
	    ii = i+START;

	    if (ENDW < Knmax)
		disp_knm(i, g);
	    if (isLength(ii))        
		continue;

	    x = get_dx(i);
	    g.setColor(Color.gray); // 
	    g.fillOval(x, get_dh(log_base(Ibase[wtok(ii)-1])*hb),
		       Dot, Dot);

	    g.setColor(getWireColor(ii));
	    set_color(g, ii);
	    for (int j = 1; j <= PART; j++)
		g.fillOval(x, get_dh(log_base(getInha(ii,j))*hb),
			   Dot, Dot);
	}
	if (PART > 1) {
	    g.setColor(Color.red);
	    g.drawString(PART+":P", W/2, FNT);
	}
    }

    public void disp_wire(Graphics g) {
	double gp = BD/8d, gw;  // 1/8
	int ws = (int)(30*TD), ii, hi; 

        g.setColor(Color.yellow);  // Ǹ
        g.drawLine(ws, 0, ws, H-1);

        for (int i = 0; i < ENDW; i++) {
	    ii = i+START;
	    if (isLength(ii))              
		continue;

	    hi = get_hd(i);
            g.setColor(Color.darkGray); // a key
            if (wtok(ii) % OCT == 1) 
                g.drawLine(0, hi, W-1, hi);

	    g.setColor(getWireColor(ii));
	    gw = getLength(ii)*gp;
	   
	    set_color(g, ii); 
	    g.drawLine((int)(ws-gw), hi, (int)(ws+gw*7), hi); // 1:7
        }
    }
    public int get_dh(double val) {
	return (int)(HT-val);
    }
    public int get_dx(int wn) {
	return (int)(WST+WD*wn);
    }
    public int get_hd(int wn) {
	return GU ? (int)(HS+HD*wn) : (int)(HD*(ENDW-wn)-HS);
    }
    public void disp_ten(Graphics g) {
        double tenn ,tens = 0;
        int i, ii, hi;

        g.setColor(Color.orange);
        for (i = 0; i < ENDW; i++) {
	    ii = i+START;
	    hi = get_hd(i);

	    //System.out.println(i+": T: "+getDensity(ii)+
	    //	       " GT: "+getGtension(ii));

	    tenn = isLength(ii) ? 0 : getGtension(ii);
	    tens = isCopper(ii) ? tens+tenn : tens+tenn*Chord;

	    g.drawOval((int)(tenn*TD-Dsf), hi-Dsf, Dot, Dot); 
	}

	String tn = "Ton("+Chord+"):"+dform(tens/1000);
	int tl = fm.stringWidth(tn);
	g.setColor(Color.green);
	g.drawString(tn, W-tl, H-FNT*2);

	int sh;
	double uni = 10.0; // 10[kgf]
	double tmax = Tmax/uni;
	g.setColor(Color.yellow);
	for (i = 0; i < tmax; i++) {
	    sh = (int)(TD*uni*i);
	    g.drawLine(sh, H-1, sh, H-getsv(i));

	    if (i%5 == 0)
		g.drawString(dform0(uni*i), sh, H-FNT);
	}

	String str = "[kgf]";
	int len = fm.stringWidth(str);
	g.drawString(str, W-len, H-FNT);
    }
    public void set_color(Graphics g, int n) {
	if (n == BW)
	    g.setColor((Vsw == INTE) ? Cb : C0); // orange:magenta
	else if (n == WN) 
	    g.setColor(Cn);   // green
    }  
    public int getsv(int n){  // tension memori
	int sv = 5;
	if (n%5 == 0) 
	    sv = 10;
	else if (n%10 == 0) 
	    sv = 15;
	return sv;
    }

    public void disp_strees(Graphics g) {
        double smax = 250d;  // stress max 
        double st, ws = W/smax;
        int ii, hi;

        g.setColor(Cst);
        for (int i = 0; i < ENDW; i++) {
	    ii = i+START;
	    hi = get_hd(i);
	    st = isLength(ii) ? 0 : getStress(ii); // NaNб

	    g.drawOval((int)(st*ws-Dsf), hi-Dsf, Dot, Dot);
        }

	int sh;
	double uni = 10.0; // 10[kgf/mm2]
	double sm = smax/uni;
	for (int i = 0; i < (int)sm; i++) {
	    sh = (int)(ws*uni*i);
            g.drawLine(sh, 0, sh, getsv(i));

	    if (i%5 == 0)
		g.drawString(dform0(uni*i), sh, FNT*2);
        }

	String str = "[kgf/mm2]";
	int len = fm.stringWidth(str);
	g.drawString(str, W-len, FNT*2);
    }
}